	.include "2313def.inc"
	
	.def acc=R16
	.def count=R17
	.def i2c_data=R18
	.def flags=R19
	.equ ACK=1;	   (0- )
	.equ SCL=4;	  SCL
	.equ SDA=5;	  SDA
	.equ SL_ADR=0x40;	slave-address 

	.macro trans_byte @0
	ldi i2c_data,@0
	rcall i2c_trans
	.endm;		     @0  i2c

	rjmp init
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti;	interrupt vectors

init:	ldi acc,ramend
	out spl,R16;	stack init
	sbi PORTD,SCL
	sbi DDRD,SCL;	i2c lines init
	rcall i2c_start
	trans_byte SL_ADR
	trans_byte 0x55
	rcall i2c_stop
	rcall i2c_start
	trans_byte SL_ADR+1
	rcall i2c_res_ack
	ldi ZL,0x060
	clr ZH
	st Z+,i2c_data
	rcall i2c_res_no_ack
	st Z+,i2c_data
	rcall i2c_stop
	rcall i2c_start
	trans_byte SL_ADR
	trans_byte 0x60
	rcall i2c_stop
	

	rjmp PC

;	i2c low level subprograms
i2c_start:	
	sbi PORTD,SCL
	rcall short_delay
	sbi DDRD,SDA
	rcall short_delay
	ret

i2c_trans:	ldi count,0x09
	cbi PORTD,SCL
	rcall short_delay
	rol i2c_data
	dec count
	breq ack_test
	brcs PC+3
	sbi DDRD,SDA
	rjmp PC+2
	cbi DDRD,SDA
	rcall short_delay
	sbi PORTD,SCL
	rcall short_delay
	rjmp i2c_trans+1

ack_test:	cbi DDRD,SDA
	rcall short_delay
	sbi PORTD,SCL
	rcall short_delay
	cbi PORTD,SCL
	ret
	

i2c_res_no_ack:	sbr flags,1<<ACK
	rjmp PC+2
i2c_res_ack: cbr flags,1<<ACK
	ldi count,0x08
	cbi PORTD,SCL
	rcall short_delay
	sbi PORTD,SCL
	sbic PIND,SDA
	rjmp PC+3
	clc
	rjmp PC+2
	sec
	rol i2c_data
	rcall short_delay
	dec count
	brne i2c_res_ack+2;	  

	cbi PORTD,SCL
	rcall short_delay
	sbrc flags,ACK
	rjmp no_ack
	sbi DDRD,SDA;	   ACK=0,      SDA ( ACK)
	rjmp PC+2
no_ack:	cbi DDRD,SDA;	   ACK=1,      SDA (  ACK)
	rcall short_delay
	sbi PORTD,SCL
	rcall short_delay;	   SCL,   slave     ACK
	cbi PORTD,SCL
	rcall short_delay;
	cbi DDRD,SDA
	ret


i2c_stop:	sbi DDRD,SDA
	rcall short_delay
	sbi PORTD,SCL
	rcall short_delay
	cbi DDRD,SDA
	rcall short_delay
	ret

short_delay:	push count
	ldi count,0x02
	dec count 
	brne PC-1
	pop count
	ret